import * as Vue from 'vue';
import { AxiosRequestConfig } from 'axios';
import { BaseRequestAction, HttpServiceBuilder, Meta, Metas, MetasLoading } from '../core';
export declare const requestActionProxyKeys: {
    methods: (keyof RequestAction<any, any, any, any, any>)[];
};
export declare class RequestAction<Data, Builder extends (...args: any[]) => HttpServiceBuilder<Data, Response, Payload, AxiosRequestConfig, M>, Response, Payload, M> extends BaseRequestAction<Data, Builder, Response, Payload, M> {
    useMeta(): Vue.ComputedRef<Meta>;
    useMeta<T extends keyof Meta>(key?: T): Vue.ComputedRef<Meta[T]>;
    useMetas(): Vue.ComputedRef<Metas<M>>;
    useMetas(value: M): Vue.ComputedRef<Meta>;
    useMetas<T extends keyof Meta>(value: M, metaKey: T): Vue.ComputedRef<Meta[T]>;
    useLoading(): Vue.ComputedRef<boolean>;
    useLoadings(): Vue.ComputedRef<MetasLoading<M>>;
    useLoadings(value: M): Vue.ComputedRef<boolean>;
    protected _getLoadingHandler(metas: Vue.ComputedRef<Metas<M>>): Vue.ComputedRef<MetasLoading<M>>;
    protected getProxyMethods(): string[];
}
