"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseAction = exports.actionProxyKeys = void 0;
var tslib_1 = require("tslib");
var isCompressed_1 = require("../utils/isCompressed");
var setActionName_1 = require("../utils/setActionName");
exports.actionProxyKeys = {
    methods: ['setName', 'getSuccessType'],
    getters: [],
};
var BaseAction = /** @class */ (function () {
    function BaseAction(model) {
        this.instanceName = '';
        this.model = model;
        if (isCompressed_1.isCompressed()) {
            this.setName(setActionName_1.increaseActionCounter());
        }
    }
    BaseAction.prototype.getSuccessType = function () {
        return this.__successType || (setActionName_1.setActionName(this), this.__successType);
    };
    BaseAction.prototype.getActionName = function () {
        return this.instanceName || (setActionName_1.setActionName(this), this.instanceName);
    };
    BaseAction.prototype.setName = function (name) {
        this.instanceName = this.model.getReducerName() + '_' + name;
        this.__successType = this.instanceName + ' success';
    };
    BaseAction.prototype.proxy = function () {
        var e_1, _a, e_2, _b;
        var _this = this;
        var methods = {};
        var fn = this.getProxyFn();
        var _loop_1 = function (method) {
            methods[method] = this_1[method].bind(this_1);
            Object.defineProperty(fn, method, {
                get: function () { return methods[method]; },
            });
        };
        var this_1 = this;
        try {
            for (var _c = tslib_1.__values(this.getProxyMethods()), _d = _c.next(); !_d.done; _d = _c.next()) {
                var method = _d.value;
                _loop_1(method);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var _loop_2 = function (property) {
            Object.defineProperty(fn, property, {
                get: function () { return _this[property]; },
            });
        };
        try {
            for (var _e = tslib_1.__values(this.getProxyGetters()), _f = _e.next(); !_f.done; _f = _e.next()) {
                var property = _f.value;
                _loop_2(property);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // @see Action.__isAction__
        fn['__isAction__'] = true;
        // @ts-ignore
        // @ts-expect-error
        return fn;
    };
    BaseAction.prototype.getProxyMethods = function () {
        return exports.actionProxyKeys.methods;
    };
    BaseAction.prototype.getProxyGetters = function () {
        return exports.actionProxyKeys.getters;
    };
    return BaseAction;
}());
exports.BaseAction = BaseAction;
