"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComposeAction = exports.composeActionProxyKeys = void 0;
var tslib_1 = require("tslib");
var BaseAction_1 = require("./BaseAction");
var MetaModel_1 = require("../models/MetaModel");
var setActionName_1 = require("../utils/setActionName");
var StoreHelper_1 = require("../stores/StoreHelper");
exports.composeActionProxyKeys = {
    methods: tslib_1.__spread(['onSuccess', 'onPrepare', 'onFail', 'getPrepareType', 'getFailType'], BaseAction_1.actionProxyKeys.methods),
    getters: tslib_1.__spread(['meta', 'loading'], BaseAction_1.actionProxyKeys.getters),
};
// FIXME: 这里的Meta是子集，也许有必要做一个ComposeMeta
var ComposeAction = /** @class */ (function (_super) {
    tslib_1.__extends(ComposeAction, _super);
    function ComposeAction(model, runner, fromSubClass) {
        if (fromSubClass === void 0) { fromSubClass = false; }
        var _this = _super.call(this, model) || this;
        _this.runner = runner;
        return fromSubClass ? _this : _this.proxy();
    }
    Object.defineProperty(ComposeAction.prototype, "meta", {
        get: function () {
            return MetaModel_1.metaModel.getMeta(this.instanceName) || MetaModel_1.DEFAULT_META;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComposeAction.prototype, "loading", {
        get: function () {
            return this.meta.loading;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @override
     */
    ComposeAction.prototype.getProxyMethods = function () {
        return exports.composeActionProxyKeys.methods;
    };
    /**
     * @override
     */
    ComposeAction.prototype.getProxyGetters = function () {
        return exports.composeActionProxyKeys.getters;
    };
    ComposeAction.prototype.getProxyFn = function () {
        var _this = this;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return tslib_1.__awaiter(_this, void 0, void 0, function () {
                var e_1;
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            StoreHelper_1.storeHelper.dispatch({
                                type: this.getPrepareType(),
                                metaKey: true,
                                metaActionName: this.instanceName,
                                loading: true,
                            });
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, this.runner.apply(this, tslib_1.__spread(args))];
                        case 2:
                            _a.sent();
                            StoreHelper_1.storeHelper.dispatch({
                                type: this.getSuccessType(),
                                metaKey: true,
                                metaActionName: this.instanceName,
                                loading: false,
                            });
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            StoreHelper_1.storeHelper.dispatch({
                                type: this.getFailType(),
                                metaKey: true,
                                metaActionName: this.instanceName,
                                message: e_1.message,
                                loading: false,
                            });
                            throw e_1;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
    };
    /**
     * @override
     */
    ComposeAction.prototype.setName = function (name) {
        _super.prototype.setName.call(this, name);
        this.__prepareType = this.instanceName + ' prepare';
        this.__failType = this.instanceName + ' fail';
    };
    ComposeAction.prototype.getPrepareType = function () {
        return this.__prepareType || setActionName_1.setActionName(this).__prepareType;
    };
    ComposeAction.prototype.getFailType = function () {
        return this.__failType || setActionName_1.setActionName(this).__failType;
    };
    ComposeAction.prototype.onSuccess = function (effect) {
        return {
            when: this.getSuccessType(),
            effect: effect,
        };
    };
    ComposeAction.prototype.onPrepare = function (effect) {
        return {
            when: this.getPrepareType(),
            effect: effect,
        };
    };
    ComposeAction.prototype.onFail = function (effect) {
        return {
            when: this.getFailType(),
            effect: effect,
        };
    };
    ComposeAction.proxyKeys = {
        methods: tslib_1.__spread(['onSuccess', 'onPrepare', 'onFail', 'getPrepareType', 'getFailType'], BaseAction_1.actionProxyKeys.methods),
        getters: tslib_1.__spread(['meta', 'loading'], BaseAction_1.actionProxyKeys.getters),
    };
    return ComposeAction;
}(BaseAction_1.BaseAction));
exports.ComposeAction = ComposeAction;
