import { StoreHelper, ReduxStoreConfig } from './StoreHelper';
import { PersistStorage } from './PersistStorage';
export declare const TYPE_REHYDRATE = "ReduxModel/rehydrate";
export declare class Persist {
    protected readonly keyPrefix = "ReduxModel:Persist:";
    protected readonly storeHelper: StoreHelper;
    protected readonly schema: {
        __persist: {
            version: number | string;
        };
    };
    protected config: ReduxStoreConfig['persist'];
    protected bootstrapped: boolean;
    protected allowKeys: string[];
    protected mapFromModelToKey: Record<string, string | undefined>;
    protected persistReducers: Record<string, any>;
    protected serializedStrings: Record<string, string>;
    protected subscription: string[];
    protected readyEvents: Function[];
    protected storage: PersistStorage;
    protected restoreTimer: number;
    constructor(storeHelper: StoreHelper);
    setConfig(config: ReduxStoreConfig['persist']): this;
    rehydrate(): Promise<any>;
    update(nextState: any, force: boolean): void;
    isReady(): boolean;
    getPersistData<T>(reducerName: string, state: T): T;
    protected onParsed(): this;
    protected resetAndRestore(): this;
    protected onBootstrapped(): this;
    listen(fn: () => void): Function;
    listenOnce(fn: () => void): void;
    protected restore(): this;
}
