"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstanceName = exports.setInstanceName = void 0;
var isCompressed_1 = require("./isCompressed");
var setActionName_1 = require("./setActionName");
var instanceCounter = {};
var instanceName = '';
var modelCounter = 0;
exports.setInstanceName = function (className, alias) {
    var aliasName = alias ? "." + alias : '';
    setActionName_1.resetActionCounter();
    if (isCompressed_1.isCompressed()) {
        instanceName = 'm' + aliasName + modelCounter;
        modelCounter += 1;
        return instanceName;
    }
    instanceName = className + aliasName;
    var dictKey = "dict_" + instanceName;
    if (instanceCounter[dictKey] === undefined) {
        instanceCounter[dictKey] = 0;
    }
    else {
        instanceCounter[dictKey] += 1;
    }
    if (instanceCounter[dictKey] > 0) {
        instanceName += "-" + instanceCounter[dictKey];
    }
    setTimeout(function () {
        // Reset since Hot-Reload will increase counter every time.
        instanceCounter[dictKey] -= 1;
    });
    return instanceName;
};
exports.getInstanceName = function () {
    return instanceName;
};
