import * as Vue from 'vue';
import { AxiosRequestConfig } from 'axios';
import { BaseModel } from '../core';
import { ComposeAction } from '../actions/ComposeAction';
export declare abstract class Model<Data = null> extends BaseModel<Data, AxiosRequestConfig> {
    useData(): Vue.ComputedRef<Data>;
    useData<T>(filter: (data: Data) => T): Vue.ComputedRef<T>;
    protected compose<Fn extends (...args: any[]) => Promise<any>>(fn: Fn): Fn & ComposeAction<Data, Fn>;
}
