"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Vue = tslib_1.__importStar(require("vue"));
var clone_1 = tslib_1.__importDefault(require("clone"));
var diff_1 = require("./diff");
var core_1 = require("../core");
core_1.storeHelper.listenOnce(function (helper) {
    var getCurrentState = helper.store.getState;
    var originalState = getCurrentState();
    var observer = Vue.reactive(clone_1.default(originalState));
    helper.getState = helper.store.getState = function () {
        return observer;
    };
    helper.store.subscribe(function () {
        var currentState = getCurrentState();
        if (currentState !== originalState) {
            diff_1.applyPatch(originalState, currentState, observer);
            originalState = currentState;
        }
    });
});
